Index: /LMDZ6/trunk/libf/phylmd/thermcell_plume_6A.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/thermcell_plume_6A.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmd/thermcell_plume_6A.F90	(revision 4089)
@@ -11,61 +11,45 @@
 !thermcell_plume: calcule les valeurs de qt, thetal et w dans l ascendance
 !--------------------------------------------------------------------------
-USE IOIPSL, ONLY : getin
-USE ioipsl_getin_p_mod, ONLY : getin_p
-
-       USE print_control_mod, ONLY: prt_level
+
+       USE thermcell_ini_mod, ONLY: prt_level,fact_thermals_ed_dz,iflag_thermals_ed,RLvCP,RETV,RG
+       USE thermcell_ini_mod, ONLY: fact_epsilon, betalpha, afact, fact_shell
+       USE thermcell_ini_mod, ONLY: detr_min, entr_min, detr_q_coef, detr_q_power
+       USE thermcell_ini_mod, ONLY: mix0, thermals_flag_alim
+
        IMPLICIT NONE
 
-#include "YOMCST.h"
-#include "YOETHF.h"
-#include "FCTTRE.h"
-#include "thermcell.h"
-
-      INTEGER itap
-      INTEGER lunout1,igout
-      INTEGER ngrid,klev
-      REAL ptimestep
-      REAL ztv(ngrid,klev)
-      REAL zthl(ngrid,klev)
-      REAL po(ngrid,klev)
-      REAL zl(ngrid,klev)
-      REAL rhobarz(ngrid,klev)
-      REAL zlev(ngrid,klev+1)
-      REAL pplev(ngrid,klev+1)
-      REAL pphi(ngrid,klev)
-      REAL zpspsk(ngrid,klev)
-      REAL alim_star(ngrid,klev)
-      REAL f0(ngrid)
-      INTEGER lalim(ngrid)
-      integer lev_out                           ! niveau pour les print
-      integer nbpb
-    
-      real alim_star_tot(ngrid)
-
-      REAL ztva(ngrid,klev)
-      REAL ztla(ngrid,klev)
-      REAL zqla(ngrid,klev)
-      REAL zqta(ngrid,klev)
-      REAL zha(ngrid,klev)
-
-      REAL detr_star(ngrid,klev)
-      REAL coefc
-      REAL entr_star(ngrid,klev)
-      REAL detr(ngrid,klev)
-      REAL entr(ngrid,klev)
-
-      REAL csc(ngrid,klev)
-
-      REAL zw2(ngrid,klev+1)
-      REAL w_est(ngrid,klev+1)
-      REAL f_star(ngrid,klev+1)
-      REAL wa_moy(ngrid,klev+1)
-
-      REAL ztva_est(ngrid,klev)
-      REAL ztv_est(ngrid,klev)
-      REAL zqla_est(ngrid,klev)
-      REAL zqsatth(ngrid,klev)
-      REAL zta_est(ngrid,klev)
-      REAL ztemp(ngrid),zqsat(ngrid)
+      integer,intent(in) :: itap,lev_out,lunout1,igout,ngrid,klev
+      real,intent(in) :: ptimestep
+      real,intent(in),dimension(ngrid,klev) :: ztv
+      real,intent(in),dimension(ngrid,klev) :: zthl
+      real,intent(in),dimension(ngrid,klev) :: po
+      real,intent(in),dimension(ngrid,klev) :: zl
+      real,intent(in),dimension(ngrid,klev) :: rhobarz
+      real,intent(in),dimension(ngrid,klev+1) :: zlev
+      real,intent(in),dimension(ngrid,klev+1) :: pplev
+      real,intent(in),dimension(ngrid,klev) :: pphi
+      real,intent(in),dimension(ngrid,klev) :: zpspsk
+      real,intent(in),dimension(ngrid) :: f0
+
+      integer,intent(out) :: lalim(ngrid)
+      real,intent(out),dimension(ngrid,klev) :: alim_star
+      real,intent(out),dimension(ngrid) :: alim_star_tot
+      real,intent(out),dimension(ngrid,klev) :: detr_star
+      real,intent(out),dimension(ngrid,klev) :: entr_star
+      real,intent(out),dimension(ngrid,klev+1) :: f_star
+      real,intent(out),dimension(ngrid,klev) :: csc
+      real,intent(out),dimension(ngrid,klev) :: ztva
+      real,intent(out),dimension(ngrid,klev) :: ztla
+      real,intent(out),dimension(ngrid,klev) :: zqla
+      real,intent(out),dimension(ngrid,klev) :: zqta
+      real,intent(out),dimension(ngrid,klev) :: zha
+      real,intent(out),dimension(ngrid,klev+1) :: zw2
+      real,intent(out),dimension(ngrid,klev+1) :: w_est
+      real,intent(out),dimension(ngrid,klev) :: ztva_est
+      real,intent(out),dimension(ngrid,klev) :: zqsatth
+      integer,intent(out),dimension(ngrid) :: lmix(ngrid)
+      integer,intent(out),dimension(ngrid) :: lmix_bis(ngrid)
+      real,intent(out),dimension(ngrid) :: linter(ngrid)
+
       REAL zdw2,zdw2bis
       REAL zw2modif
@@ -73,10 +57,16 @@
       REAL zeps(ngrid,klev)
 
-      REAL linter(ngrid)
-      INTEGER lmix(ngrid)
-      INTEGER lmix_bis(ngrid)
       REAL    wmaxa(ngrid)
 
       INTEGER ig,l,k,lt,it,lm
+      integer nbpb
+
+      real,dimension(ngrid,klev) :: detr
+      real,dimension(ngrid,klev) :: entr
+      real,dimension(ngrid,klev+1) :: wa_moy
+      real,dimension(ngrid,klev) :: ztv_est
+      real,dimension(ngrid) :: ztemp,zqsat
+      real,dimension(ngrid,klev) :: zqla_est
+      real,dimension(ngrid,klev) :: zta_est
 
       real zdz,zbuoy(ngrid,klev),zalpha,gamma(ngrid,klev),zdqt(ngrid,klev),zw2m
@@ -91,29 +81,8 @@
       real zbetalpha, coefzlmel
       real eps
-      REAL REPS,RLvCp,DDT0
-      PARAMETER (DDT0=.01)
       logical Zsat
       LOGICAL active(ngrid),activetmp(ngrid)
       REAL fact_gamma,fact_gamma2,fact_epsilon2
-
-      REAL, SAVE :: fact_epsilon=0.002
-      REAL, SAVE :: betalpha=0.9
-      REAL, SAVE :: afact=2./3.
-      REAL, SAVE :: fact_shell=1.
-      REAL,SAVE :: detr_min=1.e-5
-      REAL,SAVE :: entr_min=1.e-5
-      REAL,SAVE :: detr_q_coef=0.012
-      REAL,SAVE :: detr_q_power=0.5
-      REAL,SAVE :: mix0=0.
-      INTEGER,SAVE :: thermals_flag_alim=0
-
-!$OMP THREADPRIVATE(fact_epsilon, betalpha, afact, fact_shell)
-!$OMP THREADPRIVATE(detr_min, entr_min, detr_q_coef, detr_q_power)
-!$OMP THREADPRIVATE( mix0, thermals_flag_alim)
-
-      LOGICAL, SAVE :: first=.true.
-  !$OMP THREADPRIVATE(first)
-
-
+      REAL coefc
       REAL c2(ngrid,klev)
 
@@ -122,21 +91,4 @@
 ! Initialisation
 
-      RLvCp = RLVTT/RCPD
-      IF (first) THEN
-
-     CALL getin_p('thermals_fact_epsilon',fact_epsilon)
-     CALL getin_p('thermals_betalpha',betalpha)
-     CALL getin_p('thermals_afact',afact)
-     CALL getin_p('thermals_fact_shell',fact_shell)
-     CALL getin_p('thermals_detr_min',detr_min)
-     CALL getin_p('thermals_entr_min',entr_min)
-     CALL getin_p('thermals_detr_q_coef',detr_q_coef)
-     CALL getin_p('thermals_detr_q_power',detr_q_power)
-     CALL getin_p('thermals_mix0',mix0)
-     CALL getin_p('thermals_flag_alim',thermals_flag_alim)
-
-
-      first=.false.
-      ENDIF
 
       zbetalpha=betalpha/(1.+betalpha)
@@ -786,11 +738,6 @@
 !--------------------------------------------------------------------------
 
-      USE print_control_mod, ONLY: prt_level
+      USE thermcell_ini_mod, ONLY: prt_level,fact_thermals_ed_dz,iflag_thermals_ed,RLvCP,RETV,RG
       IMPLICIT NONE
-
-#include "YOMCST.h"
-#include "YOETHF.h"
-#include "FCTTRE.h"
-#include "thermcell.h"
 
       INTEGER itap
@@ -857,6 +804,4 @@
       real betalpha,zbetalpha
       real eps, afact
-      REAL REPS,RLvCp,DDT0
-      PARAMETER (DDT0=.01)
       logical Zsat
       LOGICAL active(ngrid),activetmp(ngrid)
@@ -866,5 +811,4 @@
 ! Initialisation
 
-      RLvCp = RLVTT/RCPD
       fact_epsilon=0.002
       betalpha=0.9 
@@ -923,5 +867,5 @@
 
 !-------------------------------------------------------------------------
-! Definition de l'alimentation a l'origine dans thermcell_init
+! Definition de l'alimentation
 !-------------------------------------------------------------------------
       do l=1,klev-1
Index: /LMDZ6/trunk/libf/phylmd/wake.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/wake.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmd/wake.F90	(revision 4089)
@@ -280,4 +280,7 @@
   ! Initialisations
   ! -------------------------------------------------------------------------
+  ! ALON = 3.e5
+  ! alon = 1.E6
+
   !  Provisionnal; to be suppressed when f_shear is parameterized
   f_shear(:) = 1.       ! 0. for strong shear, 1. for weak shear
Index: /LMDZ6/trunk/libf/phylmdiso/calltherm.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/calltherm.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/calltherm.F90	(revision 4089)
@@ -7,5 +7,5 @@
      &      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs  &
      &      ,fm_therm,entr_therm,detr_therm,zqasc,clwcon0,lmax,ratqscth,  &
-     &       ratqsdiff,zqsatth,Ale_bl,Alp_bl,lalim_conv,wght_th, &
+     &       ratqsdiff,zqsatth,ale_bl,alp_bl,lalim_conv,wght_th, &
      &       zmax0,f0,zw2,fraca,ztv,zpspsk,ztla,zthl &
 !!! nrlmd le 10/04/2012
@@ -39,5 +39,6 @@
 
       implicit none
-      include "thermcell.h"
+      include "clesphys.h"
+      include "thermcell_old.h"
 
 
@@ -94,8 +95,8 @@
       real zqsatth(klon,klev)  
 !nouvelles variables pour la convection
-      real Ale_bl(klon)
-      real Alp_bl(klon)
-      real Ale(klon)
-      real Alp(klon)
+      real ale_bl(klon)
+      real alp_bl(klon)
+      real ale(klon)
+      real alp(klon)
 !RC
       !on garde le zmax du pas de temps precedent
@@ -117,4 +118,13 @@
 !********************************************************
 
+      real, dimension(klon) :: pcon
+      real, dimension(klon,klev) :: rhobarz,wth3
+      integer,dimension(klon) :: lalim
+      real, dimension(klon,klev+1) :: fm
+      real, dimension(klon,klev) :: alim_star
+      real, dimension(klon) :: zmax
+
+
+
 
 ! variables locales
@@ -130,6 +140,7 @@
       character (len=80) :: abort_message
 
-      integer i,k
+      integer i,k,isplit
       logical, save :: first=.true.
+      logical :: new_thermcell
 
 #ifdef ISO
@@ -173,6 +184,6 @@
          detr_therm(:,:)=0.
 
-         Ale_bl(:)=0.
-         Alp_bl(:)=0.
+         ale_bl(:)=0.
+         alp_bl(:)=0.
          if (prt_level.ge.10) then
           print*,'thermV4 nsplit: ',nsplit_thermals,' weak_inversion'
@@ -207,5 +218,10 @@
          if(nbptspb.GT.0) print*,'Number of points with q_seri(i,k)<=0 ',nbptspb   
 
-#ifdef ISO
+
+         new_thermcell=iflag_thermals>=15.and.iflag_thermals<=18
+#ifdef ISO
+      if (.not.new_thermcell) then
+           CALL abort_gcm('calltherm 234','isos pas prevus ici',1)
+      endif
 #ifdef ISOVERIF
       if (iso_eau.gt.0) then
@@ -217,10 +233,9 @@
 #endif
          zdt=dtime/REAL(nsplit_thermals)
+
+
          do isplit=1,nsplit_thermals
 
           if (iflag_thermals>=1000) then
-#ifdef ISO
-              CALL abort_gcm('calltherm 173','isos pas prevus ici',1)
-#endif
             CALL thermcell_2002(klon,klev,zdt,iflag_thermals   &
      &      ,pplay,paprs,pphi  &
@@ -231,7 +246,4 @@
      &      ,tau_thermals)
           else if (iflag_thermals.eq.2) then
-#ifdef ISO
-              CALL abort_gcm('calltherm 186','isos pas prevus ici',1)  
-#endif
             CALL thermcell_sec(klon,klev,zdt  &
      &      ,pplay,paprs,pphi,zlev  &
@@ -242,8 +254,4 @@
      &      ,tau_thermals)
           else if (iflag_thermals.eq.3) then
-#ifdef ISO
-              write(*,*) 'calltherm 199: isos pas prévus ici'
-              stop
-#endif
             CALL thermcell(klon,klev,zdt  &
      &      ,pplay,paprs,pphi  &
@@ -254,7 +262,4 @@
      &      ,tau_thermals)
           else if (iflag_thermals.eq.10) then
-#ifdef ISO
-              CALL abort_gcm('calltherm 212','isos pas prevus ici',1)  
-#endif
             CALL thermcell_eau(klon,klev,zdt  &
      &      ,pplay,paprs,pphi  &
@@ -264,22 +269,8 @@
      &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
      &      ,tau_thermals)
-#ifdef ISO
-              CALL abort_gcm('calltherm 267','isos pas prevus ici',1)  
-#endif
           else if (iflag_thermals.eq.11) then
               abort_message = 'cas non prevu dans calltherm'
               CALL abort_physic (modname,abort_message,1)
-
-!           CALL thermcell_pluie(klon,klev,zdt  &
-!   &      ,pplay,paprs,pphi,zlev  &
-!    &      ,u_seri,v_seri,t_seri,q_seri  &
-!    &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
-!    &      ,zfm_therm,zentr_therm,zqla  &
-!    &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
-!    &      ,tau_thermals,3)
           else if (iflag_thermals.eq.12) then
-#ifdef ISO
-              CALL abort_gcm('calltherm 282','isos pas prevus ici',1)  
-#endif
             CALL calcul_sec(klon,klev,zdt  &
      &      ,pplay,paprs,pphi,zlev  &
@@ -289,19 +280,7 @@
      &      ,tau_thermals)
           else if (iflag_thermals==13.or.iflag_thermals==14) then
-#ifdef ISO
-              CALL abort_gcm('calltherm 292','isos pas prevus ici',1)  
-#endif
-            CALL thermcellV0_main(itap,klon,klev,zdt  &
-     &      ,pplay,paprs,pphi,debut  &
-     &      ,u_seri,v_seri,t_seri,q_seri  &
-     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
-     &      ,zfm_therm,zentr_therm,zdetr_therm,zqasc,zqla,lmax  &
-     &      ,ratqscth,ratqsdiff,zqsatth  &
-     &      ,r_aspect_thermals,l_mix_thermals  &
-     &      ,tau_thermals,Ale,Alp,lalim_conv,wght_th &
-     &      ,zmax0,f0,zw2,fraca)
-          else if (iflag_thermals>=15.and.iflag_thermals<=18) then
-
-!            print*,'THERM iflag_thermas_ed=',iflag_thermals_ed
+              abort_message = 'thermcellV0_main enleve svn>2084'
+              CALL abort_physic (modname,abort_message,1)
+          else if (new_thermcell) then
             CALL thermcell_main(itap,klon,klev,zdt  &
      &      ,pplay,paprs,pphi,debut  &
@@ -310,22 +289,26 @@
      &      ,zfm_therm,zentr_therm,zdetr_therm,zqasc,zqla,lmax  &
      &      ,ratqscth,ratqsdiff,zqsatth  &
-!    &      ,r_aspect_thermals,l_mix_thermals &
-!    &      ,tau_thermals,iflag_thermals_ed,iflag_coupl &
-     &      ,Ale,Alp,lalim_conv,wght_th &
      &      ,zmax0,f0,zw2,fraca,ztv,zpspsk &
-     &      ,ztla,zthl &
-!!! nrlmd le 10/04/2012
-     &      ,pbl_tke,pctsrf,omega,airephy &
-     &      ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
-     &      ,n2,s2,ale_bl_stat &
-     &      ,therm_tke_max,env_tke_max &
-     &      ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &
-     &      ,alp_bl_conv,alp_bl_stat &
-!!! fin nrlmd le 10/04/2012
-     &      ,ztva &
+     &      ,ztla,zthl,ztva &
+     &      ,pcon,rhobarz,wth3,wmax_sec,lalim,fm,alim_star,zmax &
 #ifdef ISO         
      &      ,xt_seri,d_xt_the &
 #endif         
      &   ) 
+
+            CALL thermcell_alp(klon,klev,zdt  &                      ! in
+     &        ,pplay,paprs  &                                        ! in
+     &        ,zfm_therm,zentr_therm,lmax  &                         ! in
+     &        ,pbl_tke,pctsrf,omega,airephy &                        ! in
+     &        ,zw2,fraca &                                           ! in
+     &        ,pcon,rhobarz,wth3,wmax_sec,lalim,fm,alim_star,zmax &  ! in
+     &        ,ale,alp,lalim_conv,wght_th &                          ! out
+     &        ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &! out
+     &        ,n2,s2,ale_bl_stat &                                   ! out
+     &        ,therm_tke_max,env_tke_max &                           ! out
+     &        ,alp_bl_det,alp_bl_fluct_m,alp_bl_fluct_tke &          ! out
+     &        ,alp_bl_conv,alp_bl_stat &                             ! out
+     &        )
+
            if (prt_level.gt.10) write(lunout,*)'Apres thermcell_main OK'
          else
@@ -423,9 +406,9 @@
        DO i=1,klon
             fm_therm(i,klev+1)=0.
-            Ale_bl(i)=Ale_bl(i)+Ale(i)/REAL(nsplit_thermals)
-!            write(22,*)'ALE CALLTHERM',Ale_bl(i),Ale(i)
-            Alp_bl(i)=Alp_bl(i)+Alp(i)/REAL(nsplit_thermals)
-!            write(23,*)'ALP CALLTHERM',Alp_bl(i),Alp(i)
-        if(prt_level.GE.10) print*,'calltherm i Alp_bl Alp Ale_bl Ale',i,Alp_bl(i),Alp(i),Ale_bl(i),Ale(i)
+            ale_bl(i)=ale_bl(i)+ale(i)/REAL(nsplit_thermals)
+!            write(22,*)'ALE CALLTHERM',ale_bl(i),ale(i)
+            alp_bl(i)=alp_bl(i)+alp(i)/REAL(nsplit_thermals)
+!            write(23,*)'ALP CALLTHERM',alp_bl(i),alp(i)
+        if(prt_level.GE.10) print*,'calltherm i alp_bl alp ale_bl ale',i,alp_bl(i),alp(i),ale_bl(i),ale(i)
        ENDDO
 
Index: /LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/isotopes_routines_mod.F90	(revision 4089)
@@ -16016,5 +16016,4 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "thermcell.h"
 #include "compbl.h"      
 
@@ -16201,5 +16200,5 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "thermcell.h"
+!  #include "thermcell.h"
 #include "compbl.h"
 
@@ -16589,5 +16588,5 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "thermcell.h"
+! #include "thermcell.h"
 #include "compbl.h"    
 
Index: /LMDZ6/trunk/libf/phylmdiso/phyetat0.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4089)
@@ -59,5 +59,5 @@
   include "dimsoil.h"
   include "clesphys.h"
-  include "thermcell.h"
+  include "alpale.h"
   include "compbl.h"
   include "YOMCST.h"
Index: /LMDZ6/trunk/libf/phylmdiso/phyredem.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4089)
@@ -56,5 +56,5 @@
   include "dimsoil.h"
   include "clesphys.h"
-  include "thermcell.h"
+  include "alpale.h"
   include "compbl.h"
   !======================================================================
@@ -504,5 +504,5 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "thermcell.h"
+#include "alpale.h"
 #include "compbl.h"      
       ! inputs
Index: /LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4089)
@@ -59,5 +59,5 @@
     IMPLICIT NONE
     include "clesphys.h"
-    include "thermcell.h"
+    include "alpale.h"
     include "YOMCST.h"
 
Index: /LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/phys_state_var_mod.F90	(revision 4089)
@@ -1,4 +1,4 @@
 !
-! $Id: phys_state_var_mod.F90 3888 2021-05-05 10:50:37Z jyg $
+! $Id: phys_state_var_mod.F90 4088 2022-03-10 07:03:20Z fhourdin $
 !
       MODULE phys_state_var_mod
Index: /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4088)
+++ /LMDZ6/trunk/libf/phylmdiso/physiq_mod.F90	(revision 4089)
@@ -78,4 +78,5 @@
     USE write_field_phy
     USE lscp_mod, ONLY : lscp
+    USE thermcell_ini_mod, ONLY : thermcell_ini
 
     !USE cmp_seri_mod
@@ -421,5 +422,5 @@
     include "dimsoil.h"
     include "clesphys.h"
-    include "thermcell.h"
+    include "alpale.h"
     include "dimpft.h"
     !======================================================================
@@ -1868,4 +1869,9 @@
 
        CALL iniradia(klon,klev,paprs(1,1:klev+1))
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       CALL thermcell_ini(iflag_thermals,prt_level,tau_thermals,lunout, &
+   &    RG,RD,RCPD,RKAPPA,RLVTT,RETV)
        !
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
